#include <stdlib.h>

class array
{
private:
	int nin;	// number of elements
	long int *counters;// counters
	int ncounters;
	char **strings;// strings
	int *hashes;

	void	do_sort(int subindex, int start, int end);

public:
	array(int numberofcounters);
	~array();

	int	addstring(char *string, int defvalue, char case_insensitive);
	int	addelement(char *string, int hash);
	int	getn(void) { return nin; }
	char *	getstring(int index) { return strings[index]; }
	int	gethash(int index) { return hashes[index]; }
	int	genhash(char *string, char case_insensitive);

	void	sort(int subindex);
	int	compare_elements(int eli1, int eli2, int subindex);
	void	swap_entry(int index1, int index2);

	inline	void	setcounter(int index, int subindex, long int value) { counters[(index * ncounters) + subindex] = value; }
	inline	long int	addcounter(int index, int subindex, long int value) { return counters[(index * ncounters) + subindex] += value; }
	inline	long int	getcounter(int index, int subindex) { return counters[(index * ncounters) + subindex]; }
};
